/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : di feb  4 15:33:11 CET 2003
    copyright            : (C) 2003 by Tom Deblauwe <tom.deblauwe@pandora.be>
                         : (C) 2005 by Isaac Clerencia <isaac@warp.es>
                         : (C) 2007 by Zsolt Branyiczky <brazso@zematix.hu>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for QT
#include <qfile.h>

// include files for KDE
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "ksubtile.h"

static const char *description =
	I18N_NOOP("KSubtile, an SRT subtitle editor");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{
	KLocale::setMainCatalogue("ksubtile");    

	KAboutData aboutData( "ksubtile", I18N_NOOP("KSubtile"),
		"1.3", description, KAboutData::License_GPL,
		"(c) 2003-2007, Tom Deblauwe", 0, "http://ksubtile.sourceforge.net", "brazso@users.sourceforge.net");
	aboutData.addAuthor("Tom Deblauwe", I18N_NOOP("Main programmer"), "tom.deblauwe@pandora.be");
	aboutData.addAuthor("Isaac Clerencia", I18N_NOOP("Programmer"), "isaac@warp.es");
	aboutData.addCredit("Dimitris Michail", I18N_NOOP("Bug fixes & find subtitles in list feature"), "michail@mpi-sb.mpg.de");
	aboutData.addCredit("Zsolt Branyiczky", I18N_NOOP("Current maintainer"), "brazso@users.sourceforge.net");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

	KApplication app;

	if (app.isRestored()) {
		RESTORE(KSubtileApp);
	} else {
		KSubtileApp *ksubtile = new KSubtileApp();
		ksubtile->show();

		KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

		if (args->count()) {
			QString file = QFile::decodeName(args->arg(0));
			ksubtile->openDocumentFile(file);
		} else {
			ksubtile->openDocumentFile();
		}
		args->clear();
	}

	return app.exec();
}  
